#ifndef FSEMU_KEYBOARD_H_
#define FSEMU_KEYBOARD_H_

#include "fsemu-common.h"
// #include "fsemu-scancode.h"

#ifdef FSEMU_OS_MACOS
#define FSEMU_KEYBOARD_MOD_NAME "Cmd"
#else
#define FSEMU_KEYBOARD_MOD_NAME "Alt"
#endif

/*
#ifdef __APLE__
#define FSE_MODIFIER_SDL KMOD_LGUI
#define FSE_MODIFIER_SDL_SUFFIX LGUI
#else
#define FSE_MODIFIER_SDL KMOD_LALT
#define FSE_MODIFIER_SDL_SUFFIX LALT
#endif

#define FSE_SHORTCUT_QUIT_SDL SDLK_q
#define FSE_SHORTCUT_QUIT_UPPER Q
#define FSE_SHORTCUT_QUIT_LOWER q
*/

#ifdef __cplusplus
extern "C" {
#endif

void fsemu_keyboard_add_devices(void);

#define FSEMU_KEYBOARD_MOD_MOD 1
#define FSEMU_KEYBOARD_MOD_SHIFT 2
#define FSEMU_KEYBOARD_NUM_MODS 3

// These correspond 1:1 to SDL _scan codes_, so for the SDL2 input driver, we
// can simply assign the scancode directly without lookup table.
typedef enum {
    FSEMU_KEYBOARD_UNKNOWN_KEY = 0,

    FSEMU_KEYBOARD_A = 4,
    FSEMU_KEYBOARD_B = 5,
    FSEMU_KEYBOARD_C = 6,
    FSEMU_KEYBOARD_D = 7,
    FSEMU_KEYBOARD_E = 8,
    FSEMU_KEYBOARD_F = 9,
    FSEMU_KEYBOARD_G = 10,
    FSEMU_KEYBOARD_H = 11,
    FSEMU_KEYBOARD_I = 12,
    FSEMU_KEYBOARD_J = 13,
    FSEMU_KEYBOARD_K = 14,
    FSEMU_KEYBOARD_L = 15,
    FSEMU_KEYBOARD_M = 16,
    FSEMU_KEYBOARD_N = 17,
    FSEMU_KEYBOARD_O = 18,
    FSEMU_KEYBOARD_P = 19,
    FSEMU_KEYBOARD_Q = 20,
    FSEMU_KEYBOARD_R = 21,
    FSEMU_KEYBOARD_S = 22,
    FSEMU_KEYBOARD_T = 23,
    FSEMU_KEYBOARD_U = 24,
    FSEMU_KEYBOARD_V = 25,
    FSEMU_KEYBOARD_W = 26,
    FSEMU_KEYBOARD_X = 27,
    FSEMU_KEYBOARD_Y = 28,
    FSEMU_KEYBOARD_Z = 29,
    FSEMU_KEYBOARD_1 = 30,
    FSEMU_KEYBOARD_2 = 31,
    FSEMU_KEYBOARD_3 = 32,
    FSEMU_KEYBOARD_4 = 33,
    FSEMU_KEYBOARD_5 = 34,
    FSEMU_KEYBOARD_6 = 35,
    FSEMU_KEYBOARD_7 = 36,
    FSEMU_KEYBOARD_8 = 37,
    FSEMU_KEYBOARD_9 = 38,
    FSEMU_KEYBOARD_0 = 39,
    FSEMU_KEYBOARD_RETURN = 40,
    FSEMU_KEYBOARD_ESCAPE = 41,
    FSEMU_KEYBOARD_BACKSPACE = 42,
    FSEMU_KEYBOARD_TAB = 43,
    FSEMU_KEYBOARD_SPACE = 44,
    FSEMU_KEYBOARD_MINUS = 45,
    FSEMU_KEYBOARD_EQUALS = 46,
    FSEMU_KEYBOARD_LEFTBRACKET = 47,
    FSEMU_KEYBOARD_RIGHTBRACKET = 48,
    FSEMU_KEYBOARD_BACKSLASH = 49,
    FSEMU_KEYBOARD_NONUSHASH = 50,
    FSEMU_KEYBOARD_SEMICOLON = 51,
    FSEMU_KEYBOARD_APOSTROPHE = 52,
    FSEMU_KEYBOARD_GRAVE = 53,
    FSEMU_KEYBOARD_COMMA = 54,
    FSEMU_KEYBOARD_PERIOD = 55,
    FSEMU_KEYBOARD_SLASH = 56,
    FSEMU_KEYBOARD_CAPSLOCK = 57,
    FSEMU_KEYBOARD_F1 = 58,
    FSEMU_KEYBOARD_F2 = 59,
    FSEMU_KEYBOARD_F3 = 60,
    FSEMU_KEYBOARD_F4 = 61,
    FSEMU_KEYBOARD_F5 = 62,
    FSEMU_KEYBOARD_F6 = 63,
    FSEMU_KEYBOARD_F7 = 64,
    FSEMU_KEYBOARD_F8 = 65,
    FSEMU_KEYBOARD_F9 = 66,
    FSEMU_KEYBOARD_F10 = 67,
    FSEMU_KEYBOARD_F11 = 68,
    FSEMU_KEYBOARD_F12 = 69,
    FSEMU_KEYBOARD_PRINTSCREEN = 70,
    FSEMU_KEYBOARD_SCROLLLOCK = 71,
    FSEMU_KEYBOARD_PAUSE = 72,
    FSEMU_KEYBOARD_INSERT = 73,
    FSEMU_KEYBOARD_HOME = 74,
    FSEMU_KEYBOARD_PAGEUP = 75,
    FSEMU_KEYBOARD_DELETE = 76,
    FSEMU_KEYBOARD_END = 77,
    FSEMU_KEYBOARD_PAGEDOWN = 78,
    FSEMU_KEYBOARD_RIGHT = 79,
    FSEMU_KEYBOARD_LEFT = 80,
    FSEMU_KEYBOARD_DOWN = 81,
    FSEMU_KEYBOARD_UP = 82,
    FSEMU_KEYBOARD_NUMLOCKCLEAR = 83,
    FSEMU_KEYBOARD_KPDIVIDE = 84,
    FSEMU_KEYBOARD_KPMULTIPLY = 85,
    FSEMU_KEYBOARD_KPMINUS = 86,
    FSEMU_KEYBOARD_KPPLUS = 87,
    FSEMU_KEYBOARD_KPENTER = 88,
    FSEMU_KEYBOARD_KP1 = 89,
    FSEMU_KEYBOARD_KP2 = 90,
    FSEMU_KEYBOARD_KP3 = 91,
    FSEMU_KEYBOARD_KP4 = 92,
    FSEMU_KEYBOARD_KP5 = 93,
    FSEMU_KEYBOARD_KP6 = 94,
    FSEMU_KEYBOARD_KP7 = 95,
    FSEMU_KEYBOARD_KP8 = 96,
    FSEMU_KEYBOARD_KP9 = 97,
    FSEMU_KEYBOARD_KP0 = 98,
    FSEMU_KEYBOARD_KPPERIOD = 99,
    FSEMU_KEYBOARD_NONUSBACKSLASH = 100,
    FSEMU_KEYBOARD_APPLICATION = 101,
    FSEMU_KEYBOARD_POWER = 102,
    FSEMU_KEYBOARD_KPEQUALS = 103,
    FSEMU_KEYBOARD_F13 = 104,
    FSEMU_KEYBOARD_F14 = 105,
    FSEMU_KEYBOARD_F15 = 106,
    FSEMU_KEYBOARD_F16 = 107,
    FSEMU_KEYBOARD_F17 = 108,
    FSEMU_KEYBOARD_F18 = 109,
    FSEMU_KEYBOARD_F19 = 110,
    FSEMU_KEYBOARD_F20 = 111,
    FSEMU_KEYBOARD_F21 = 112,
    FSEMU_KEYBOARD_F22 = 113,
    FSEMU_KEYBOARD_F23 = 114,
    FSEMU_KEYBOARD_F24 = 115,
    FSEMU_KEYBOARD_EXECUTE = 116,
    FSEMU_KEYBOARD_HELP = 117,
    FSEMU_KEYBOARD_MENU = 118,
    FSEMU_KEYBOARD_SELECT = 119,
    FSEMU_KEYBOARD_STOP = 120,
    FSEMU_KEYBOARD_AGAIN = 121,
    FSEMU_KEYBOARD_UNDO = 122,
    FSEMU_KEYBOARD_CUT = 123,
    FSEMU_KEYBOARD_COPY = 124,
    FSEMU_KEYBOARD_PASTE = 125,
    FSEMU_KEYBOARD_FIND = 126,
    FSEMU_KEYBOARD_MUTE = 127,
    FSEMU_KEYBOARD_VOLUMEUP = 128,
    FSEMU_KEYBOARD_VOLUMEDOWN = 129,

    FSEMU_KEYBOARD_KPCOMMA = 133,
    FSEMU_KEYBOARD_KPEQUALSAS400 = 134,
    FSEMU_KEYBOARD_INTERNATIONAL1 = 135,
    FSEMU_KEYBOARD_INTERNATIONAL2 = 136,
    FSEMU_KEYBOARD_INTERNATIONAL3 = 137,
    FSEMU_KEYBOARD_INTERNATIONAL4 = 138,
    FSEMU_KEYBOARD_INTERNATIONAL5 = 139,
    FSEMU_KEYBOARD_INTERNATIONAL6 = 140,
    FSEMU_KEYBOARD_INTERNATIONAL7 = 141,
    FSEMU_KEYBOARD_INTERNATIONAL8 = 142,
    FSEMU_KEYBOARD_INTERNATIONAL9 = 143,
    FSEMU_KEYBOARD_LANG1 = 144,
    FSEMU_KEYBOARD_LANG2 = 145,
    FSEMU_KEYBOARD_LANG3 = 146,
    FSEMU_KEYBOARD_LANG4 = 147,
    FSEMU_KEYBOARD_LANG5 = 148,
    FSEMU_KEYBOARD_LANG6 = 149,
    FSEMU_KEYBOARD_LANG7 = 150,
    FSEMU_KEYBOARD_LANG8 = 151,
    FSEMU_KEYBOARD_LANG9 = 152,
    FSEMU_KEYBOARD_ALTERASE = 153,
    FSEMU_KEYBOARD_SYSREQ = 154,
    FSEMU_KEYBOARD_CANCEL = 155,
    FSEMU_KEYBOARD_CLEAR = 156,
    FSEMU_KEYBOARD_PRIOR = 157,
    FSEMU_KEYBOARD_RETURN2 = 158,
    FSEMU_KEYBOARD_SEPARATOR = 159,
    FSEMU_KEYBOARD_OUT = 160,
    FSEMU_KEYBOARD_OPER = 161,
    FSEMU_KEYBOARD_CLEARAGAIN = 162,
    FSEMU_KEYBOARD_CRSEL = 163,
    FSEMU_KEYBOARD_EXSEL = 164,

    FSEMU_KEYBOARD_KP00 = 176,
    FSEMU_KEYBOARD_KP000 = 177,
    FSEMU_KEYBOARD_THOUSANDSSEPARATOR = 178,
    FSEMU_KEYBOARD_DECIMALSEPARATOR = 179,
    FSEMU_KEYBOARD_CURRENCYUNIT = 180,
    FSEMU_KEYBOARD_CURRENCYSUBUNIT = 181,
    FSEMU_KEYBOARD_KPLEFTPAREN = 182,
    FSEMU_KEYBOARD_KPRIGHTPAREN = 183,
    FSEMU_KEYBOARD_KPLEFTBRACE = 184,
    FSEMU_KEYBOARD_KPRIGHTBRACE = 185,
    FSEMU_KEYBOARD_KPTAB = 186,
    FSEMU_KEYBOARD_KPBACKSPACE = 187,
    FSEMU_KEYBOARD_KPA = 188,
    FSEMU_KEYBOARD_KPB = 189,
    FSEMU_KEYBOARD_KPC = 190,
    FSEMU_KEYBOARD_KPD = 191,
    FSEMU_KEYBOARD_KPE = 192,
    FSEMU_KEYBOARD_KPF = 193,
    FSEMU_KEYBOARD_KPXOR = 194,
    FSEMU_KEYBOARD_KPPOWER = 195,
    FSEMU_KEYBOARD_KPPERCENT = 196,
    FSEMU_KEYBOARD_KPLESS = 197,
    FSEMU_KEYBOARD_KPGREATER = 198,
    FSEMU_KEYBOARD_KPAMPERSAND = 199,
    FSEMU_KEYBOARD_KPDBLAMPERSAND = 200,
    FSEMU_KEYBOARD_KPVERTICALBAR = 201,
    FSEMU_KEYBOARD_KPDBLVERTICALBAR = 202,
    FSEMU_KEYBOARD_KPCOLON = 203,
    FSEMU_KEYBOARD_KPHASH = 204,
    FSEMU_KEYBOARD_KPSPACE = 205,
    FSEMU_KEYBOARD_KPAT = 206,
    FSEMU_KEYBOARD_KPEXCLAM = 207,
    FSEMU_KEYBOARD_KPMEMSTORE = 208,
    FSEMU_KEYBOARD_KPMEMRECALL = 209,
    FSEMU_KEYBOARD_KPMEMCLEAR = 210,
    FSEMU_KEYBOARD_KPMEMADD = 211,
    FSEMU_KEYBOARD_KPMEMSUBTRACT = 212,
    FSEMU_KEYBOARD_KPMEMMULTIPLY = 213,
    FSEMU_KEYBOARD_KPMEMDIVIDE = 214,
    FSEMU_KEYBOARD_KPPLUSMINUS = 215,
    FSEMU_KEYBOARD_KPCLEAR = 216,
    FSEMU_KEYBOARD_KPCLEARENTRY = 217,
    FSEMU_KEYBOARD_KPBINARY = 218,
    FSEMU_KEYBOARD_KPOCTAL = 219,
    FSEMU_KEYBOARD_KPDECIMAL = 220,
    FSEMU_KEYBOARD_KPHEXADECIMAL = 221,

    FSEMU_KEYBOARD_LCTRL = 224,
    FSEMU_KEYBOARD_LSHIFT = 225,
    FSEMU_KEYBOARD_LALT = 226,
    FSEMU_KEYBOARD_LGUI = 227,
    FSEMU_KEYBOARD_RCTRL = 228,
    FSEMU_KEYBOARD_RSHIFT = 229,
    FSEMU_KEYBOARD_RALT = 230,
    FSEMU_KEYBOARD_RGUI = 231,

    FSEMU_KEYBOARD_MODE = 257,
    FSEMU_KEYBOARD_AUDIONEXT = 258,
    FSEMU_KEYBOARD_AUDIOPREV = 259,
    FSEMU_KEYBOARD_AUDIOSTOP = 260,
    FSEMU_KEYBOARD_AUDIOPLAY = 261,
    FSEMU_KEYBOARD_AUDIOMUTE = 262,
    FSEMU_KEYBOARD_MEDIASELECT = 263,
    FSEMU_KEYBOARD_WWW = 264,
    FSEMU_KEYBOARD_MAIL = 265,
    FSEMU_KEYBOARD_CALCULATOR = 266,
    FSEMU_KEYBOARD_COMPUTER = 267,
    FSEMU_KEYBOARD_ACSEARCH = 268,
    FSEMU_KEYBOARD_ACHOME = 269,
    FSEMU_KEYBOARD_ACBACK = 270,
    FSEMU_KEYBOARD_ACFORWARD = 271,
    FSEMU_KEYBOARD_ACSTOP = 272,
    FSEMU_KEYBOARD_ACREFRESH = 273,
    FSEMU_KEYBOARD_ACBOOKMARKS = 274,
    FSEMU_KEYBOARD_BRIGHTNESSDOWN = 275,
    FSEMU_KEYBOARD_BRIGHTNESSUP = 276,
    FSEMU_KEYBOARD_DISPLAYSWITCH = 277,
    FSEMU_KEYBOARD_KBDILLUMTOGGLE = 278,
    FSEMU_KEYBOARD_KBDILLUMDOWN = 279,
    FSEMU_KEYBOARD_KBDILLUMUP = 280,
    FSEMU_KEYBOARD_EJECT = 281,
    FSEMU_KEYBOARD_SLEEP = 282,
    FSEMU_KEYBOARD_APP1 = 283,
    FSEMU_KEYBOARD_APP2 = 284,
    FSEMU_KEYBOARD_AUDIOREWIND = 285,
    FSEMU_KEYBOARD_AUDIOFASTFORWARD = 286,

    // SDL_NUM_SCANCODES is 512 at the time of writing, but we don't need to
    // waste space for unsupported keys, so FSEMU_NUM_SCANCODES is set as low
    // as possible. Just remember to check that SDL scancode is less than
    // FSEMU_KEYBOARD_NUM_KEYS before passing on.
    FSEMU_KEYBOARD_NUM_KEYS
} FSEMU_KEYBOARD_t;

#ifdef __cplusplus
}
#endif

#endif  // FSEMU_KEYBOARD_H_
